=== debian/changelog ===
ros-bouncy-uncrustify-vendor (0.66.1-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 28 Jun 2018 01:23:48 -0000
